/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2015.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rational.carter.ide.client.context.contextHelper");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("jazz.ui.RemoteChooserResponder");
dojo.require("rmps.app.core.internal.Workarounds");
dojo.require("rmps.core.BackendScr");

dojo.require("rmps.core.streams.StreamClient");
dojo.require("rmps.app.ui.internal.util.UrlUtil");
dojo.require("rmps.core.util.ContextUtils");
var ContextUtils = rmps.core.util.ContextUtils;

dojo.require("rmps.core.RootServices");
dojo.require("carter.ui.RootServices");

var StreamClient = rmps.core.streams.StreamClient;
var UrlUtil= rmps.app.ui.internal.util.UrlUtil;

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpCommunicator");
var RhpCommunicator = com.ibm.rational.carter.ide.client.internal.RhpCommunicator;




var rhp_review_workBench = {
		registerOnBeforeUnloadHandler: function(){
			
		},
		unregisterNavigateAwayHandler: function(){
			
		},
		showMessage: function() {
			
		},
		hideMessageArea: function() {
			
		},
		setTitle: function() {
			
		},
		setPageDirty: function() {
		
		},
		currentPageId: "com.ibm.rational.carter.ide.client.helper.contextHelper"
	};
	
com.ibm.rational.carter.ide.client.context.contextHelper = {
		
	initialized: false,
	_currentUser: null,
	
	initFromFragment: function () {

		var projectName = rhpUtils.getFragment("projectName");
		var projectArea = RhpProjectAreaInfo.getProjectAreaByName(projectName);

		if (projectArea) {
			var currentContext = rhpUtils.getFragment("oslc_config.context");
			if (projectArea && currentContext)
				this.setContext(projectArea, currentContext);
		}
	
	},
	
	setContext: function(projectArea,baseline) {
		
		this.setProjectArea(projectArea);
		if (baseline !== null) {
			this.setContextActually(baseline);
		}
		else
		{
			defaultStreamGet = StreamClient.getDefaultStream();
			defaultStreamGet.addCallback(this.setContextActually(streamUri));
		}
		
		RhpCommunicator.notifyRhapsody({
			cmd: "projectareaselected",
			params: [(projectArea !== null)?projectArea.name:null,baseline]
		});

	},
	
	setContextActually: function(streamUri) {
		jazz.app.context.get().baseline = streamUri;	
	},
	
	setProjectArea: function(projectArea) {
		if (projectArea !== null)
		{
			dojo.getObject("currentApplication", true, jazz.app).context = projectArea.url;
			dojo.getObject("currentApplication", true, jazz.app).applicationContext = projectArea;
			jazz.app.context.set(projectArea);
			//Todo
			jazz.app.currentApplication.applicationContext.uri = jazz.app.currentApplication.applicationContext.url;
			dojo.getObject("net.jazz.ajax.ui.PlatformUI",true);

			
		}
		this.init();
	},

	getProjectArea: function() {
		return jazz.app.context.get();
	},
	
	getContext: function() {
		return jazz.app.context.get().baseline;
	},
	
	setUser: function(user)
	{
		if (user !== null)
		{
			this._currentUser = user;
			this._currentUser.userId = this._currentUser.id;
			dojo.getObject("currentApplication", true, jazz.app);
			dojo.getObject("config", true, jazz.app.currentApplication).user = user;
		}
		this.init();
	},
	
	getModels: function(projectId, contextUri)
	{
		var uri = carter.ui.RootServices.getUri(carter.ui.Namespaces.CARTER, "publish");
		uri += "?client=true&projectId=" + projectId + "&oslc_config.context=" + escape(contextUri);
		var args = {
				url: uri,
				handleAs: "xml",
				sync: true,
				load: function(response, ioArgs) {
					return response;
				},
				error: function(response, ioArgs) {
					rmps.core.error.createXhrError(ioArgs).dispatch();
				}
		};
		return jazz.client.xhrGet(args);
	},
	
	init: function() {
		
		if (this.initialized) {
			return;
		}
		else {
			this.initialized = true;
		}
		net.jazz.ajax.ui.PlatformUI.getWorkbench = function(){
			return rhp_review_workBench;
		};
		jazz.client.xhrGet({
			url: rmps.core.BackendScr.get().getUriForPath([
				{namespace: rmps.core.Namespaces.JUENTRY, name: "JTSApplicationAdminLinksService"},
				{namespace: rmps.core.Namespaces.JD_1_0,name: "service"}
			]),
			headers: {
				"Accept": "application/rdf+json",
				"X-ibm-rmps-internal": "true"
			},
			handleAs: "json",
			sync: true,
			load: dojo.hitch(this, function(response) {
				this.processTemplateManagementUrl= response.processTemplateManagement.url;
				jazz.app.context.get().applicationId= UrlUtil.getParamater(this.processTemplateManagementUrl, UrlUtil.OWNNING_APPLICATION_KEY);
			})
		});
		
	}
};

}());