/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2015.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

function noError(){return true;}

(function() {
dojo.provide("com.ibm.rational.carter.ide.client.debug.DebugWidget");
dojo.require("jazz.app.proxy");
dojo.require("jazz.app.auth");
dojo.require("jazz.app.events");
dojo.require("jazz.app.proxy");
dojo.require("rmps.app.pickers.internal.SelectionsPicker");

dojo.require("jazz.ui.SimpleToolbar");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("dojox.html");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojo.hash");

dojo.require("rmps.core.RootServices");

dojo.require("rmps.app.core.util");

dojo.require("rmps.core.BackendScr");

dojo.require("rmps.ui.editor.EditorUtil");

dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants");

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo");
var RhpProjectAreaInfo = com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo;

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpCommunicator");
var RhpCommunicator = com.ibm.rational.carter.ide.client.internal.RhpCommunicator;

dojo.requireLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");
var rhpMessages = dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");

dojo.require("rmps.app.ui.internal.util.UrlUtil");
var UrlUtil= rmps.app.ui.internal.util.UrlUtil;

dojo.requireLocalization("rmps.ui.common", "CommonMessages");
var commonMessages = dojo.i18n.getLocalization("rmps.ui.common", "CommonMessages");

dojo.require("rmps.core.streams.StreamClient");

var StreamClient = rmps.core.streams.StreamClient;
dojo.require("com.ibm.rational.carter.ide.client.connection.connectionWidget");

dojo.require("rmps.ui.resource.ResourceIconLabel");

dojo.require("rmps.app.ui.internal.comment.SketchContribution");

dojo.require("com.ibm.rational.carter.ide.client.context.contextHelper");
var contextHelper = com.ibm.rational.carter.ide.client.context.contextHelper;

dojo.require("rmps.app.ui.internal.pages.design.DesignUtil");
var DesignUtil= rmps.app.ui.internal.pages.design.DesignUtil;

dojo.require( "rmps.core.Enum" );

com.ibm.rational.carter.ide.client.debug.DebugWidget.ButtonsNames = new rmps.core.Enum({
    B_DANGLING_RESOURCES: new rmps.core.EnumLiteral({name: rhpMessages.button_connectdanglingresources, value: "connectdanglingresources"}),
    B_MULTIPLE_OWNERS: new rmps.core.EnumLiteral({name: rhpMessages.button_findMultipleOwners, value: "findMultipleOwners"}),
    B_UNRESOLVE: new rmps.core.EnumLiteral({name: rhpMessages.button_findUnresolvedAggregates, value: "findUnresolvedAggregates"})
});

var ButtonsNames = com.ibm.rational.carter.ide.client.debug.DebugWidget.ButtonsNames;

dojo.declare("com.ibm.rational.carter.ide.client.debug.DebugWidget", [dijit._Widget, dijit._Templated], {
	
	"class": "root",
	rhpMessages : dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages"),
	templateString: dojo.cache("com.ibm.rational.carter.ide.client", "debug/templates/DebugWidget.html"),

	
	
	// private properties
	_projectArea: null,
	_baseline: null,

	_connectionWidget: null,
	_runButton: null,

	_editorUtil: null,
	_editorInput: null,
	_toolbarContainer:null,
	_modelsSelector:null,
	_buttonsMap : null,
	

	buildRendering: function() {
		this.inherited(arguments);
		this.containerNode = this.domNode;
	},
	
	postCreate: function() {
		//triggers the login window if needed
		if (RhpCommunicator.login() === false) {
			return;
		}

		contextHelper.init(true);
		var deferred = RhpProjectAreaInfo.init();
		deferred.addCallback(this,this.init);
	},
	
	createConnectionWidget: function() {
		if (this._connectionWidget === null) {
			this._connectionWidget = new com.ibm.rational.carter.ide.client.connection.connectionWidget(true);
			this.connectionContainer.appendChild(this._connectionWidget.domNode);
			
			dojo.connect(this._connectionWidget, "_onSelectBaseline", this, this._onSelectBaseline);
			if (this._connectionWidget._currentProjectArea !== null && this._connectionWidget._currentContext !== null) {
				this._onSelectBaseline(this._connectionWidget._currentProjectArea, this._connectionWidget._currentContext);
			}
			
			if( this._modelsSelector === null ) {
				this._modelsSelector = new com.ibm.rational.carter.ide.client.debug._ModelsSelector();
				if( this._modelsSelector !== null ) {
					this._connectionWidget.domNode.appendChild(this._modelsSelector.domNode);
				}
			}
			this._addSpace(this._modelsSelector.domNode);
			this._runButton = new rmps.ui.SimpleButton({
				label: rhpMessages.run_tests,
				onClick: dojo.hitch(this, this._onRunTests)
			});
			this._modelsSelector.domNode.appendChild(this._runButton.domNode);
			this._runButton.setEnabled(this._modelsSelector._modelSelected !== null);
		} 

	},
	
	_onRunTests: function() {
		this._runButton.setEnabled(false);
		this.textContainer.value = rhpMessages.Loading_results;
		var deffer = this.runTests(this._connectionWidget._currentContext, this._modelsSelector._modelSelected);
		if(deffer) {
			deffer.addCallback(this, this._showResults);
		}
		this._runButton.setEnabled(this._modelsSelector._modelSelected !== null);
	},
	
	_showResults: function(xmlReport) {
		if(this._buttonsMap === null) {
			this._buttonsMap = new Map();
		}
		var UIHelper = com.ibm.team.process.web.ui.internal.admin.projects.UIHelper;
        var reportsNode = UIHelper.getNode(xmlReport.childNodes, "Reports", null); //$NON-NLS-1$
        var reports = UIHelper.getNodes(reportsNode.childNodes, "Report", null); //$NON-NLS-1$
        var text = "";
        dojo.forEach(reports, function(report){
            var testName = UIHelper.getAttributeNode(report, "name", null).nodeValue;//$NON-NLS-1$
            var reportNode = UIHelper.getNode(report.childNodes, "Data", null); //$NON-NLS-1$
            var reportStr = reportNode.firstChild.data;
            text += reportStr;    
            var fixUriNode = UIHelper.getNode(report.childNodes, "FixUri", null); //$NON-NLS-1$
            var fixUri = (fixUriNode !== undefined && fixUriNode.firstChild !== undefined) ? fixUriNode.firstChild.data : "";
            if(fixUri !== "") {
                this._addFixButton(testName, fixUri);
            } else {
                this._enableFixButton(testName, false);
            }

        }, this);
		this.textContainer.value = text; 
	},
	
	_enableFixButton: function(testName, enable) {
		var button = this._buttonsMap.get(testName);
        if(button) {
            button.setEnabled(enable);
        }
	},
	
	_createFixButton: function(testName, fixUri) {
		var fixButton = new rmps.ui.SimpleButton({
			label: ButtonsNames.get(testName).name,
			uri: fixUri,
			onClick: dojo.hitch(this, function(){
				this._onFix(testName, fixUri);
			})
		});
		this.fixButtonsContainer.appendChild(fixButton.domNode);
		this._addSpace(this.fixButtonsContainer);
		this._buttonsMap.set(testName, fixButton);
		this._enableFixButton(testName, true);
	},
	
	_addSpace: function(container) {
		var info = dojo.doc.createElement("span");
		info.innerHTML = "&nbsp;";
		container.appendChild(info);
	},
	
	_updateButtonUri: function(testName, fixUri) {
		var fixButton = this._buttonsMap.get(testName);
		if(fixButton) {
			fixButton.uri = fixUri;
		}
		this._buttonsMap.set(testName, fixButton);
		this._enableFixButton(testName, true);
	},
	
	_addFixButton: function(testName, fixUri) {
		if (this._buttonsMap.has(testName)) {
			this._updateButtonUri(testName, fixUri);
		}
		else {
			this._createFixButton(testName, fixUri);
		}
	},
	
	_runCommand: function(uri) {
		var args = {
				url: uri,
				sync: true,
				load: function(response, ioArgs) {
					return response;
				},
				error: function(response, ioArgs) {
					rmps.core.error.createXhrError(ioArgs).dispatch();
				}
		};
		return jazz.client.xhrGet(args);
	},
	
	_onFix: function(testName, fixUri) {
		this._enableFixButton(testName, false);
		this._runButton.setEnabled(false);
		this.textContainer.value = rhpMessages.Fixing;
		var deffered = this._runCommand(fixUri);
		if(deffered) {
			deffered.addCallback(this, this._showFixResults);
		}		
		this._runButton.setEnabled(this._modelsSelector._modelSelected !== null);
	},
	
	_showFixResults: function(report) {
		this.textContainer.value = report; 
	},
	
	runTests: function(contextUri, modelUri)
	{
		var uri = carter.ui.RootServices.getUri(carter.ui.Namespaces.CARTER, "utils");
		uri += "?action=runAllTests&modelUri=" + escape(modelUri) + "&oslc_config.context=" + escape(contextUri);
		var args = {
				url: uri,
				sync: true,
				handleAs: "xml",
				load: function(response, ioArgs) {
					return response;
				},
				error: function(response, ioArgs) {
					rmps.core.error.createXhrError(ioArgs).dispatch();
				}
		};
		return jazz.client.xhrGet(args);
	},
	
	_onSelectBaseline: function(projectArea, baseline)
	{
		this._modelsSelector._setModels(projectArea, baseline);
		this._runButton.setEnabled(this._modelsSelector._modelSelected !== null);
	},
	
	destroy: function() {
		this.inherited(arguments);
	},
	
	init: function() {
		this.createConnectionWidget();
	}

});

dojo.declare("com.ibm.rational.carter.ide.client.debug._ModelsSelector", [dijit._Widget, dijit._Templated], {
	
	modelsContainer: null,
	_modelSelected: null,
	rhpMessages : dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages"),
	
	templateString: '<span>' +
	'<label dojoAttachPoint="contextLabel"> ${rhpMessages.Model} </label>' + 
	'<select dojoAttachPoint="modelsContainer" dojoAttachEvent="onchange: _onModelChanged">' +
	'</select>' +
	'</span>',
	
	_setModels: function(projectArea, contextUri) {
		contextHelper.setContext(projectArea, contextUri);
		var deferred = contextHelper.getModels(projectArea.itemId, contextUri);
		if (deferred) {
			deferred.addCallback(this, this._parseModels);
		}
	},
	
	_parseModels: function(xmlDocument) {
		var UIHelper = com.ibm.team.process.web.ui.internal.admin.projects.UIHelper;
        var children = xmlDocument.childNodes;
        var modelsNode = UIHelper.getNode(children, "Projects", null); //$NON-NLS-1$
        var modelsChildren = modelsNode.childNodes;
		var models = UIHelper.getNodes(modelsChildren, "Project", null); //$NON-NLS-1$
		var results = [];
        dojo.forEach(models, function(model){
               var modelChildren = model.childNodes;

                var modelNameNode = UIHelper.getNode(modelChildren, "ProjectName", null); //$NON-NLS-1$
                var modelName = modelNameNode.firstChild.data;
                
                var modelUriNode = UIHelper.getNode(modelChildren, "ProjectUri", null); //$NON-NLS-1$
                var modelUri = modelUriNode.firstChild.data;
				
				var data = {
						name: modelName,
						uri: modelUri
				};
				results.push(data);

            }, this);
		
        this._removeAllOptions(this.modelsContainer);
		var option;
		for (i = 0; i < results.length; i++) {
			this._addOption(this.modelsContainer, results[i].name, results[i].uri);
		}
		this._modelSelected = null;
		if(results.length > 0) {
			this.modelsContainer.selectedIndex = 0;
			this._modelSelected = results[0].uri;
		}
	},
	
	_onModelChanged: function(event) {
		this._modelSelected = event.target.options[event.target.selectedIndex].value;
	},
	
	_addOption: function(selection, label, value) {
		var option = dojo.create("option", { "value" : value }, selection, null);
		var text = dojo.doc.createTextNode(label);
		option.appendChild(text);
		return option;
	},
	
	_removeAllOptions: function(selection) {
		while (selection.options.length > 0){
			selection.remove(0);
		}
	}
});
}());
