/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2015.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
// Client side constants:
var SCHED_DISABLE 			= 0;
var SCHED_ENABLE 			= 1;
var SCHEDTYPE_INTERVAL 		= 1;
var SCHEDTYPE_FIXED			= 2;

(function() {

dojo.provide("carter.ui.editors.Activity");

dojo.require("rmps.core.resource.Resource");
dojo.require("rmps.core.user.UserClient");
dojo.require( "rmps.core.Enum" );

var SCHED_DEFINTERVAL		= 60;

// RDF constants: 
var RDF_ACTTYPE 		= "http://ibm.com/carter/1.0/definitionId";
var RDF_ACTREQUESTER	= "http://ibm.com/carter/1.0/definitionName";
var RDF_ACTREQUESTTIME 	= "http://ibm.com/carter/1.0/modelname";
var RDF_ACTSTARTTIME 	= "http://ibm.com/carter/1.0/schedule";
var RDF_ACTDURATION 	= "http://ibm.com/carter/1.0/scheduleType";
var RDF_STATUS 			= "http://ibm.com/carter/1.0/scheduleInterval";

var RDF_REQUESTER 		= "http://ibm.com/carter/1.0/requester";
var RDF_REQUEST_ID 		= "http://ibm.com/carter/1.0/requestId";
var RDF_ACTIVITY_TYPE 	= "http://ibm.com/carter/1.0/activitytype";
var RDF_START_TIME 		= "http://ibm.com/carter/1.0/startTime";
var RDF_REQUEST_TIME 	= "http://ibm.com/carter/1.0/requestTime";
var RDF_STOP_TIME 		= "http://ibm.com/carter/1.0/stopTime";
var RDF_STATE 			= "http://ibm.com/carter/1.0/state";
var RDF_DETAILS 		= "http://ibm.com/carter/1.0/details";
var RDF_STAGE 			= "http://ibm.com/carter/1.0/stage";
var RDF_EXCEPTION		= "http://ibm.com/carter/1.0/exception";
var RDF_EXCEPTION_KEY	= "http://ibm.com/carter/1.0/exceptionKeyword";
var RDF_DROP_CAUSE		= "http://ibm.com/carter/1.0/dropCause";
var RDF_ACTIVITY_MODEL	= "http://ibm.com/carter/1.0/activityModel";
var RDF_ACTIVITY_MODEL_NAME = "http://ibm.com/carter/1.0/activityModelName";

//specific warnings
var RDF_WARNINGS						= "http://ibm.com/carter/1.0/warning_";
var RDF_WARN_unknownProfile				= RDF_WARNINGS + "errUnknownProfile";
var RDF_WARN_mismatchedProfileVersion	= RDF_WARNINGS + "mismatchedProfileVersion"; //not used yet
var RDF_WARN_saveIndexing				= RDF_WARNINGS + "errSaveIndexing";
var RDF_WARN_assocDomainByManifest		= RDF_WARNINGS + "errAssocDomainByManifest";
var RDF_WARN_updateDomain				= RDF_WARNINGS + "errUpdateDomain";
var RDF_WARN_unloadedElements			= RDF_WARNINGS + "errUnloadedElements";
var RDF_WARN_NotTopLevelRef				= RDF_WARNINGS + "errNotTopLevelRef";
var RDF_WARN_notOnServerProfile			= RDF_WARNINGS + "errNotOnServerProfile";
var RDF_WARN_dupGUID					= RDF_WARNINGS + "errDupGUID";
var RDF_WARN_systemProfileNotInOMROOT	= RDF_WARNINGS + "errSystemProfileNotInOMROOT";



//specific warnings
var RDF_ERR								= "http://ibm.com/carter/1.0/error_";
var RDF_ERR_nonAsciiModelName			= RDF_ERR + "errNonAsciiModelName";
var RDF_ERR_notOnServerProfile			= RDF_ERR + "errNotOnServerProfile";
var RDF_ERR_dupGUID						= RDF_ERR + "errDupGUID";
var RDF_ERR_UnsupportedProfiles			= RDF_ERR + "errUnsupportedProfiles";



//progress
var RDF_PROGRESS						= "http://ibm.com/carter/1.0/progress_";
var RDF_PROG_deletedResources			= RDF_PROGRESS + "deletedResources";
var RDF_PROG_savedResources				= RDF_PROGRESS + "savedResources";


// Carter reuqirements:
dojo.requireLocalization("carter.ui", "EditorMessages");
dojo.require("carter.ui.utils");

var messages = dojo.i18n.getLocalization("carter.ui", "EditorMessages");

var UserClient = rmps.core.user.UserClient;


carter.ui.editors.Activity.states = new rmps.core.Enum({
	UNKNOWN: new rmps.core.EnumLiteral({name: messages.unknown, value: "unknown", icon: dojo.moduleUrl("carter.ui", "graphics/icons/states/state_unknown.gif")}),
	PENDING: new rmps.core.EnumLiteral({name: messages.pending, value: "pending", icon: dojo.moduleUrl("carter.ui", "graphics/icons/states/state_pending.gif")}),
	IN_PROGRESS: new rmps.core.EnumLiteral({name: messages.inProgress, value: "inProgress", icon: dojo.moduleUrl("carter.ui", "graphics/icons/states/state_inProgress.gif")}),
	ERROR: new rmps.core.EnumLiteral({name: messages.error, value: "error", icon: dojo.moduleUrl("carter.ui", "graphics/icons/states/state_error.gif")}),
	DROPPED: new rmps.core.EnumLiteral({name: messages.dropped, value: "dropped", icon: dojo.moduleUrl("carter.ui", "graphics/icons/states/state_dropped.gif")}),
	COMPLETED: new rmps.core.EnumLiteral({name: messages.completed, value: "completed", icon: dojo.moduleUrl("carter.ui", "graphics/icons/states/state_completed.gif")}),
	WARNING: new rmps.core.EnumLiteral({name: messages.warning, value: "warning", icon: dojo.moduleUrl("carter.ui", "graphics/icons/states/state_warning.gif")}),
	CANCELED: new rmps.core.EnumLiteral({name: messages.canceled, value: "canceled", icon: dojo.moduleUrl("carter.ui", "graphics/icons/states/state_canceled.gif")}),
	CANCELING: new rmps.core.EnumLiteral({name: messages.canceling, value: "canceling", icon: dojo.moduleUrl("carter.ui", "graphics/icons/states/state_canceling.gif")}),
	WITH_ERRORS: new rmps.core.EnumLiteral({name: messages.completedWithErrors, value: "completedWithErrors", icon: dojo.moduleUrl("carter.ui", "graphics/icons/states/state_error.gif")})
});

carter.ui.editors.Activity.stages = new rmps.core.Enum({
    ENGINE_WAIT: new rmps.core.EnumLiteral({name: messages.engineWait, value: "enginewait"}),
    IMPORT_INIT: new rmps.core.EnumLiteral({name: messages.importInit, value: "importInit"}),
	CHECK_PERMISSION: new rmps.core.EnumLiteral({name: messages.checkPermission, value: "checkPermission"}),
	GENERATE_RDF: new rmps.core.EnumLiteral({name: messages.generateRdfFiles, value: "generateRdfFiles"}),
	CREATE_ENGINE: new rmps.core.EnumLiteral({name: messages.createEngine, value: "initEngine"}),
	ENSURE_CONTEXT: new rmps.core.EnumLiteral({name: messages.ensureContext, value: "ensureContext"}),
	ASSOCIATE_UML_DOMAIN: new rmps.core.EnumLiteral({name: messages.associateUNLDomain, value: "associateUNLDomain"}),
	ASSOCIATE_DOMAINS: new rmps.core.EnumLiteral({name: messages.associateDomains, value: "associateDomains"}),
	CREATE_CHANGEST: new rmps.core.EnumLiteral({name: messages.createEditingSession, value: "createEditingSession"}),
	CANCEL_CHANGEST: new rmps.core.EnumLiteral({name: messages.cancelEditingSession, value: "cancelEditingSession"}),
	DELETE_ALL_RESOURCES: new rmps.core.EnumLiteral({name: messages.deleteAllResources, value: "deleteAllResources"}),
	UPDATE_USER_DOMAIN: new rmps.core.EnumLiteral({name: messages.updateUserDomains, value: "updateUserDomains"}),
	DELETE_RESOURCES: new rmps.core.EnumLiteral({name: messages.deleteResources, value: "deleteResources"}),
	SAVE_RESOURCES: new rmps.core.EnumLiteral({name: messages.saveResources, value: "saveResources"}),
	COMMIT_CHANGESET: new rmps.core.EnumLiteral({name: messages.commitEditingSession, value: "commitEditingSession"}),
	POST_COMMIT: new rmps.core.EnumLiteral({name: messages.postCommit, value: "postCommit"}),
	WAIT_FOR_INDEX: new rmps.core.EnumLiteral({name: messages.waitForIndex, value: "waitForIndex"}),
	CLEAR_DIAGRAMS: new rmps.core.EnumLiteral({name: messages.clearDiagrams, value: "clearDiagrams"}),
	CLEAR_TEMP_FOLDERS: new rmps.core.EnumLiteral({name: messages.clearFolders, value: "clearFolders"}),
	CHECK_DOMAIN: new rmps.core.EnumLiteral({name: messages.checkDomain, value: "checkDomain"}),
	SAVE_DOMAIN_RESOURCES: new rmps.core.EnumLiteral({name: messages.saveDomainResources, value: "saveDomainResources"}),
	CREATE_SNAPSHOT: new rmps.core.EnumLiteral({name: messages.createSnapshot, value: "createSnapshot"}),
	IMPORT_DOMAIN_INIT: new rmps.core.EnumLiteral({name: messages.importDomainInit, value: "importDomainInit"}),
	EXTERNAL_EXECUTERS: new rmps.core.EnumLiteral({name: messages.externalExecuters, value: "externalExecuters"}),
	INIT_DELETE_MODEL: new rmps.core.EnumLiteral({name: messages.initDeleteModel, value: "initDeleteModel"}),
	DELETE_MODEL: new rmps.core.EnumLiteral({name: messages.deleteModel, value: "deleteModel"}),
	CHECK_MODEL: new rmps.core.EnumLiteral({name: messages.checkModel, value: "checkModel"}),
	EMPTY: new rmps.core.EnumLiteral({name: "-", value: "emptyStage"})
});

carter.ui.editors.Activity.exceptionKeys = new rmps.core.Enum({
    ERR_MODEL_SERVER_DISPLAY: new rmps.core.EnumLiteral({name: messages.err_modelServerDisplay, value: "errModelServerDisplay"}),
    ERR_MODEL_SERVER_MISSING_LIB: new rmps.core.EnumLiteral({name: messages.err_modelServerMissingLib, value: "errModelServerMissingLib"}),
    ERR_MODEL_SERVER_WRONG_LOCATION: new rmps.core.EnumLiteral({name: messages.err_modelServerWrongLocation, value: "errModelServerWrongLocation"}),
    ERR_MODEL_SERVER_PERMISSION: new rmps.core.EnumLiteral({name: messages.err_modelServerPermission, value: "errModelServerPermission"}),
    ERR_MODEL_SERVER_FAILED_LAUNCH: new rmps.core.EnumLiteral({name: messages.err_modelServerFailedLaunch, value: "errFailedLaunchRhapModelServer"}),
    ERR_CHECK_PERMISSION: new rmps.core.EnumLiteral({name: messages.err_checkPermission, value: "checkPermission"}),
    ERR_SAVE_INDEXING: new rmps.core.EnumLiteral({name: messages.label_warn_saveIndexing, value: "errSaveIndexing"}),
	ERR_UNRECOGNIZE_DOMAIN_SERVICE: new rmps.core.EnumLiteral({name: messages.err_ExternalDomainService, value: "errExternalDomainService"})
});

carter.ui.editors.Activity.dropCauses = new rmps.core.Enum({
    IMPORT_ENGINE_UNRESPONSIVE: new rmps.core.EnumLiteral({name: messages.serviceUnresponsive, value: "serviceUnresponsive"})
});


var States = carter.ui.editors.Activity.states;
var Stages = carter.ui.editors.Activity.stages;
var ExceptionKeys = carter.ui.editors.Activity.exceptionKeys;
var DropCasue = carter.ui.editors.Activity.dropCauses;

dojo.declare("carter.ui.editors.Activity", rmps.core.resource.Resource, {

	stopTime: null, // Date
	startTime: null, // Date
	requestTime: null, // Date
	
	activityType: null,	
	requester: null,
	requestId: null,	
	state: null,
	details: null,
	stage: null,
	exception: null,
	exceptionMsg: null,
	dropCause: null,
	
	warn_unknownProfile: null,
	warn_mismatchedProfileVersion: null,
	warn_saveIndexing: null,
	warn_assocDomainByManifest: null,
	warn_updateDomain: null,
	warn_unloadedElements: null,
	warn_NotTopLevelRef: null,
	warn_notOnServerProfile: null,
	warn_dupGUID: null,
	warn_systemProfileNotInOMROOT: null,
	
	// errors
	err_nonAsciiModelName: null,
	err_notOnServerProfile: null,
	err_dupGUID: null,
	err_unsupportedProfiles: null,
	
	prog_deletedResources: null,
	prog_savedResources: null,
	
	importModelStatus: null,
	
	
	contentType: "application/rdf+json",
	
	constructor: function() {	
		this.resetContent();
	},
	
	resetContent: function() {
		this.activityType = null;
		this.requester = null;
		this.requestId = null;
		this.requestTime = null;		
		this.startTime = null;
		this.stopTime = null;
		this.state = null;
		this.details = null;
		this.stage = null;
		this.exception = null;
		this.exceptionMsg = null;
		this.dropCause = null;
		
		this.warn_unknownProfile = null;
		this.warn_mismatchedProfileVersion = null;
		this.warn_saveIndexing = null;
		this.warn_assocDomainByManifest = null;
		this.warn_updateDomain = null;
		this.warn_unloadedElements = null;
		this.warn_NotTopLevelRef = null;
		this.warn_notOnServerProfile = null;
		this.warn_dupGUID = null;
		warn_systemProfileNotInOMROOT: null;
		
		// errors
		this.err_nonAsciiModelName = null; 
		this.err_notOnServerProfile = null;
		this.err_dupGUID = null;
		this.err_unsupportedProfiles = null;
		
		this.prog_deletedResources = null;
		this.prog_savedResources = null;
		this.importModelStatus = null;
	},
	
	toRdfJson: function() {
	},

	parseRdfJson: function(fullRdf, uri){
		
		var rdf = fullRdf[uri];
		if( rdf[RDF_STATE] ) {
			this.state = States.get(rdf[RDF_STATE][0].value);
		}
			
		if( rdf[RDF_REQUESTER] ){
			this.requester = rdf[RDF_REQUESTER][0].value;
		}
			
		if( rdf[RDF_REQUEST_ID] ) {
			this.requestId = rdf[RDF_REQUEST_ID][0].value;
		}
		
		if( rdf[RDF_REQUEST_TIME] ) {
			this.requestTime = dojo.date.stamp.fromISOString(rdf[RDF_REQUEST_TIME][0].value);
		}
		
		if (rdf[RDF_START_TIME]) {
			this.startTime = dojo.date.stamp.fromISOString(rdf[RDF_START_TIME][0].value);
		}

		if (rdf[RDF_STOP_TIME]) {
			this.stopTime = dojo.date.stamp.fromISOString(rdf[RDF_STOP_TIME][0].value);
		}

		if (rdf[RDF_ACTIVITY_TYPE]) {
			this.activityType = rdf[RDF_ACTIVITY_TYPE][0].value;
		}	

		if (rdf[RDF_DETAILS]) {
			this.details = rdf[RDF_DETAILS][0].value;
		}	
		
		if (rdf[RDF_STAGE]) {
			this.stage = Stages.get(rdf[RDF_STAGE][0].value);
		}
		
		if (rdf[RDF_DROP_CAUSE]) {
			this.dropCause = DropCasue.get(rdf[RDF_DROP_CAUSE][0].value);
		}


		//model details
		if (rdf[RDF_ACTIVITY_MODEL]) {
			var activitiesModels = rdf[RDF_ACTIVITY_MODEL];
			this.ImportModelData = {};
			for (var i = 0; i < activitiesModels.length; ++i) {
				var activityModelBlankNode = activitiesModels[i].value;
				if (fullRdf[activityModelBlankNode]) {
					var activityModel = fullRdf[activityModelBlankNode];
					var activityModelName = null;
					if (activityModel[RDF_ACTIVITY_MODEL_NAME])
						activityModelName = activityModel[RDF_ACTIVITY_MODEL_NAME][0].value;
					else
						activityModelName = "<Default>";
					this.ImportModelData[activityModelName] = {};
					this.parseRdfJsonModelImportStatus(activityModel, this.ImportModelData[activityModelName]);
				}
			}
		}

		this.parseRdfJsonModelImportStatus(rdf, this);

	},
	
	parseRdfJsonModelImportStatus: function(rdf, currentNode) {
		
		function getArray(values) {
			var result = null;
			if (values) {
				result = [];
				for (var i = 0; i < values.length; ++i) {
					result.push(values[i].value);
				}
				result.sort();
			}
			return result;
		}

		// warnings
		currentNode.warn_unknownProfile 			= getArray(rdf[RDF_WARN_unknownProfile]);
		currentNode.warn_mismatchedProfileVersion	= getArray(rdf[RDF_WARN_mismatchedProfileVersion]);
		currentNode.warn_saveIndexing 				= getArray(rdf[RDF_WARN_saveIndexing]);
		currentNode.warn_assocDomainByManifest 	= getArray(rdf[RDF_WARN_assocDomainByManifest]);
		currentNode.warn_updateDomain 				= getArray(rdf[RDF_WARN_updateDomain]);
		currentNode.warn_unloadedElements 			= getArray(rdf[RDF_WARN_unloadedElements]);
		currentNode.warn_NotTopLevelRef 			= getArray(rdf[RDF_WARN_NotTopLevelRef]);
		currentNode.warn_notOnServerProfile 		= getArray(rdf[RDF_WARN_notOnServerProfile]);
		currentNode.warn_dupGUID 					= getArray(rdf[RDF_WARN_dupGUID]);
		currentNode.warn_systemProfileNotInOMROOT = getArray(rdf[RDF_WARN_systemProfileNotInOMROOT]);
		
		// errors
		currentNode.err_nonAsciiModelName 			= getArray(rdf[RDF_ERR_nonAsciiModelName]);
		currentNode.err_notOnServerProfile 		= getArray(rdf[RDF_ERR_notOnServerProfile]);
		currentNode.err_dupGUID 					= getArray(rdf[RDF_ERR_dupGUID]);
		currentNode.err_unsupportedProfiles 		= getArray(rdf[RDF_ERR_UnsupportedProfiles]);
		
		//import details
		if (rdf[RDF_PROG_deletedResources]) {
			currentNode.prog_deletedResources = rdf[RDF_PROG_deletedResources][0].value;
		}
		if (rdf[RDF_PROG_savedResources]) {
			currentNode.prog_savedResources = rdf[RDF_PROG_savedResources][0].value;
		}
		
		// error
		if (rdf[RDF_EXCEPTION]) {
			currentNode.exception = rdf[RDF_EXCEPTION][0].value;
			if (rdf[RDF_EXCEPTION_KEY]) {
				currentNode.exceptionMsg = ExceptionKeys.get(rdf[RDF_EXCEPTION_KEY][0].value);
			}
		}

	},
	
	getRequestTimeStr: function() {
		if( this.requestTime != null ){
			return dojo.date.locale.format(this.requestTime, {formatLength: "short"});
		}		
		return null;
	},
	
	getStartTimeStr: function() {
		if( this.startTime != null ){
			return dojo.date.locale.format(this.startTime, {formatLength: "short"});
		}		
		return null;
	},
	
	getStopTimeStr: function() {
		if( this.stopTime != null ){
			return dojo.date.locale.format(this.stopTime, {formatLength: "short"});
		}		
		return null;
	},
	
	isEnded: function(){
		if(this.state.value == States.ERROR.value || this.state.value == States.DROPPED.value ||
		this.state.value == States.CANCELED.value || this.state.value == States.COMPLETED.value ||
		this.state.value == States.WARNING.value || this.state.value == States.WITH_ERRORS.value) 
		{
			return true;
		}
		return false;
	},
	
	getRequester: function(){
/*		
		if (this._requester && this._requester.uri == this.requester) {
			var deferred = new dojo.Deferred();
			setTimeout(dojo.hitch(this, function() {
				deferred.callback(this._requester);
			}), 0);
			return deferred;
		}
		var deferred = UserClient.getUser(this.requester);
		deferred.addCallback(dojo.hitch(this, function(user) {
			this._requester = user;
		}));
		return deferred;
*/
	}	
		
});

})();
